<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlanRestrictionTypePlanRestriction ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfPlanRestrictionTypePlanRestriction extends AbstractStructArrayBase
{
    /**
     * The PlanRestriction
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction[]
     */
    public $PlanRestriction;
    /**
     * Constructor method for ArrayOfPlanRestrictionTypePlanRestriction
     * @uses DgArrayOfPlanRestrictionTypePlanRestriction::setPlanRestriction()
     * @param \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction[] $planRestriction
     */
    public function __construct(array $planRestriction = array())
    {
        $this
            ->setPlanRestriction($planRestriction);
    }
    /**
     * Get PlanRestriction value
     * @return \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction[]|null
     */
    public function getPlanRestriction()
    {
        return $this->PlanRestriction;
    }
    /**
     * Set PlanRestriction value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction[] $planRestriction
     * @return \dgsoft\ArrayType\DgArrayOfPlanRestrictionTypePlanRestriction
     */
    public function setPlanRestriction(array $planRestriction = array())
    {
        foreach ($planRestriction as $arrayOfPlanRestrictionTypePlanRestrictionPlanRestrictionItem) {
            // validation for constraint: itemType
            if (!$arrayOfPlanRestrictionTypePlanRestrictionPlanRestrictionItem instanceof \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction) {
                throw new \InvalidArgumentException(sprintf('The PlanRestriction property can only contain items of \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction, "%s" given', is_object($arrayOfPlanRestrictionTypePlanRestrictionPlanRestrictionItem) ? get_class($arrayOfPlanRestrictionTypePlanRestrictionPlanRestrictionItem) : gettype($arrayOfPlanRestrictionTypePlanRestrictionPlanRestrictionItem)), __LINE__);
            }
        }
        $this->PlanRestriction = $planRestriction;
        return $this;
    }
    /**
     * Add item to PlanRestriction value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction $item
     * @return \dgsoft\ArrayType\DgArrayOfPlanRestrictionTypePlanRestriction
     */
    public function addToPlanRestriction(\dgsoft\StructType\DgPlanRestrictionTypePlanRestriction $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction) {
            throw new \InvalidArgumentException(sprintf('The PlanRestriction property can only contain items of \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PlanRestriction[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgPlanRestrictionTypePlanRestriction|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlanRestriction
     */
    public function getAttributeName()
    {
        return 'PlanRestriction';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfPlanRestrictionTypePlanRestriction
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
